#include "devsec.h"
#include <stdlib.h>
#include <stdio.h>

#include "authdialog.h"

AuthDialog::AuthDialog(Widget *mainWindow, Widget *parent,
		int x, int y, int w, int h, int buttons)
	: Dialog(mainWindow, parent, x, y, w, h, buttons)
{
	mUsername = NULL;
	mPassword = NULL;
	SetTitle("Authorization Required");
	CreateWindow();
}

AuthDialog::~AuthDialog()
{
}

int AuthDialog::CreateWindow()
{
	Widget *label;

	SetColor(0xe600, 0xf700, 0xff00);

	label = new Widget(this, 8, 18, 64, 16);
	label->SetText("Username:", 2, 14);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);

	mUsername = new TextEntry(this, 74, 16, 234, 24);
	mUsername->Show();
	mUsername->SetFocus();

	label = new Widget(this, 8, 50, 64, 16);
	label->SetText("Password:", 2, 14);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);

	mPassword = new TextEntry(this, 74, 48, 234, 24);
	mPassword->SetHiddenText('*');
	mPassword->Show();
}

int AuthDialog::OnButtonPressed(int button)
{
	int rv;
	char buf[256];
	if ((button == DIALOG_BUTTON_CANCEL) || (button == DIALOG_BUTTON_NO))
		return Dialog::OnButtonPressed(button);
	snprintf(buf, 256, "devsec_helper checkuser %s %s", 
			mUsername->GetBufferPtr(),
			mPassword->GetBufferPtr());
	rv = my_system(buf);
	Dialog::OnButtonPressed(button);;
	if (rv != 0) mResponse = DIALOG_BUTTON_CANCEL;
	return 0;
}

char *AuthDialog::GetUsername()
{
	return mUsername->GetBufferPtr();
}

char *AuthDialog::GetPassword()
{
	return mPassword->GetBufferPtr();
}

