#ifndef __DEVSEC_EVENTS_H
#define __DEVSEC_EVENTS_H

#include "dtk_event.h"

#include <X11/X.h>
#include <X11/Xlib.h>

#define UP 0
#define DOWN 1

#define KEY_EVENT_TYPE 1
#define MOUSE_BUTTON_EVENT_TYPE 2
#define MOUSE_MOTION_EVENT_TYPE 3
#define MOTION_DETECT_EVENT_TYPE 4

typedef struct {
	unsigned char type;
	unsigned char ascii;
	unsigned char state;
} KEY_EVENT;

typedef struct {
	unsigned char type;
	unsigned char button;
	unsigned char state;
} MOUSE_BUTTON_EVENT;

typedef struct {
	unsigned char type;
	unsigned int x;
	unsigned int y;
} MOUSE_MOTION_EVENT;

typedef struct {
	unsigned char type;
	unsigned char detected;
	time_t dtime;
} MOTION_DETECT_EVENT;

typedef union {
	unsigned char type;
	KEY_EVENT key;
	MOUSE_BUTTON_EVENT mousebutton;
	MOUSE_MOTION_EVENT mousemotion;
	MOTION_DETECT_EVENT motiondetect;
} SockEvent;

// Remote events

#define LAYOUT_EVENT_TYPE 1
#define CYCLE_EVENT_TYPE 2
#define CONFIG_EVENT_TYPE 3
#define VIEW_ID_EVENT_TYPE 4

typedef struct {
	unsigned char type;
	int layout;
} LAYOUTEVENT;

typedef struct {
	unsigned char type;
	int flag;
} CYCLEEVENT;

typedef struct {
	unsigned char type;
} CONFIGEVENT;

typedef struct {
	unsigned char type;
	int camera;
	Window window;
	int w;
	int h;
	int visible;
} VIEWIDEVENT;

typedef union {
	unsigned char type;
	LAYOUTEVENT layout;
	CYCLEEVENT cycle;
	CONFIGEVENT config;
	VIEWIDEVENT viewid;
} RemoteEvent;

#endif
