#include <stdlib.h>
#include <stdio.h>
#define XK_MISCELLANY
#include <X11/keysymdef.h>

#include "dtk_widget.h"
#include "devsecconsumer.h"

DevsecConsumer::DevsecConsumer()
{
	mDCConfig = NULL;
}

DevsecConsumer::~DevsecConsumer()
{
	if (mDCConfig) {
		delete mDCConfig;
		mDCConfig = NULL;
	}
}

int DevsecConsumer::CreateMainWindow()
{
	Widget *widget;

	mMainWindow = new Widget(NULL, 0, 0, 800, 600);
	mMainWindow->WMIgnore(True);
	mMainWindow->SetTitle("Devolution Security");
	mMainWindow->DrawFrame(0);
	mMainWindow->SetResizable(0);
	mMainWindow->SetColor(0x0, 0x0, 0x0);

	widget = new Widget(mMainWindow, 16, 12, 768, 576);
	widget->SetColor(0, 0, 0);
	widget->Show();
	widget->DrawFrame(0);

	CreateCameras(widget);
	return 0;
}

int DevsecConsumer::EventHandler(TEvent *ev)
{
	if (ev->type == XEVENT) {
		switch (ev->xev->type) {
			case KeyRelease:
				if (HandleKeyPress(ev->xev))
					return 1;
		}
	}
	return Devsec::EventHandler(ev);
}

int DevsecConsumer::HandleKeyPress(XEvent *xev)
{
	char c = 0;
	KeySym keysym;

	if (xev == NULL) return 0;

	if (XLookupString(&(xev->xkey), &c, 1, &keysym, NULL) == NoSymbol) {
		keysym = XKeycodeToKeysym(Widget::GetXDisplay(),
				xev->xkey.keycode, 0);
	}

	switch (keysym) {
		case XK_F1:
			ShowConfig();
			break;
		case XK_F2:
			DoLayout(0);
			break;
		case XK_F3:
			DoLayout(1);
			break;
		case XK_F4:
			sCycling = 1 - sCycling;
			if (sCycling) DoCycle(0);
			DoCycle(1);
			break;
		case XK_F5:
			my_system("mediaplayer &");
			break;
		case XK_F10:
			my_system("cdburner &");
			break;
	}
	return 0;
}

int DevsecConsumer::ShowConfig()
{
	if (mDCConfig == NULL) {
		mDCConfig = new DCConfig(NULL, 96, 32, 608, 536);
		mDCConfig->Init();
		AddChild(mDCConfig);
	}
	if (!mDCConfig->IsVisible()) mDCConfig->Show();
	return 0;
}
