#ifndef __DEVSECREMOTE_H
#define __DEVSECREMOTE_H

#ifndef CAMERAS
#define CAMERAS 16
#endif

#include "dtk_application.h"
#include "dtk_widget.h"
#include "dtk_timer.h"
#include "dtk_socket.h"
#include "dtk_config.h"
#include "devsec_events.h"

class DevsecRemote : public Application {
public:
	DevsecRemote();
	virtual ~DevsecRemote();
	virtual int Init(int argc, char **argv);
	virtual int Destroy();

	virtual int EventHandler(TEvent *ev);
protected:
	int DoLayout(int l);
	int DoCycle(int flag);
	int DoConfig();
	int GetRemoteEvent(RemoteEvent *rev);

	static void CycleTimerCallback(void *data1, void *data2);

	SocketClient *mSocket;
	Widget **mCameras;
	Widget **mLayoutList;
	int *mLayoutNos;
	Widget *mWindow;
	Timer *mCycleTimer;
	int mNumCameras;
	int mCurrentLayout;
	int *mVisible;
};
#endif
