#ifndef __DIALOG_CAMERA_H
#define __DIALOG_CAMERA_H

#include "dtk_widget.h"
#include "dtk_slider.h"
#include "dtk_spinbox.h"
#include "dtk_button.h"
#include "dtk_checkbox.h"
#include "dtk_textentry.h"
#include "dtk_combobox.h"

class Devsec;
class Camera;

class DialogCamera : public Widget {
public:
	DialogCamera(Widget *parent, int x, int y, int w, int h,
			int numCameras, Camera **c, Devsec *d);
	virtual ~DialogCamera();

	virtual int entering();
	virtual int leaving();

	virtual int Show();
	virtual int Hide();
	virtual int SetPreviewWindow(int index);
	virtual int OnCameraListChanged(int index);
	virtual int OnSliderChanged(int slider);
	virtual int OnBoundsChanged();
	virtual int OnCheckToggled(int toggle);
	virtual int OnCameraNameChanged(int camera);

protected:
	virtual int CreateWindows();
	virtual int FillPanel(int cameraNo);

	virtual int FillComboBox(char *combostr, int length);

	static void ComboChanged(Object *o, TEvent *e, void *d1, void *d2);
	static void SliderChanged(Object *o, TEvent *e, void *d1, void *d2);
	static void BoundsChanged(Object *o, TEvent *e, void *d1, void *d2);
	static void CheckToggled(Object *o, TEvent *e, void *d1, void *d2);
	static void NameChanged(Object *o, TEvent *e, void *d1, void *d2);

	Devsec *mApp;
	Camera **mCameras;
	int mCurrentCamera;
	int mNumCameras;
	int mCurrentLayout;

	TextEntry *mCameraName;
	ComboBox *mCameraList;

	Slider *mSensitivity;
	SpinBox *mBoundsLeft;
	SpinBox *mBoundsTop;
	SpinBox *mBoundsRight;
	SpinBox *mBoundsBottom;

	CheckBox *mShowMotion;
	CheckBox *mShowBounds;

	Widget *mPreviewWindow;

	Slider *mBrightness;
	Slider *mContrast;
	Slider *mColor;

	Slider *mBitrate;

	static int ignore;
};

#endif
