#ifndef __DIALOG_GLOBAL_H
#define __DIALOG_GLOBAL_H

#include "dtk_widget.h"
#include "dtk_spinbox.h"
#include "dtk_checkbox.h"
#include "camera.h"

class Devsec;

class DialogGlobal : public Widget {
public:
	DialogGlobal(Widget *parent, int x, int y, int w, int h,
			int numCameras, Camera **c, Devsec *d);
	virtual ~DialogGlobal();

	virtual int entering();
	virtual int leaving();

	virtual int OnDeletePressed();
	virtual int OnAudiblePressed();
	virtual int OnTimeChanged();
protected:
	virtual int DownloadData();
	virtual int CreateWindows();

	static void DeletedCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void AudibleCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void TimeChangeCallback(Object *o, TEvent *e,
			void *d1, void *d2);

	Devsec *mApp;
	Camera **mCameras;
	int mNumCameras;
	Widget *mTitleImage;
	SpinBox *mMinutes;
	SpinBox *mSeconds;
	CheckBox *mDeleteOldFiles;
	CheckBox *mAudibleRecord;
};

#endif
