#ifndef __DIALOG_MOTION_H
#define __DIALOG_MOTION_H

#include "dtk_widget.h"
#include "dtk_checkbox.h"
#include "dtk_textentry.h"
#include "camera.h"

class Devsec;

class DialogMotion : public Widget {
public:
	DialogMotion(Widget *parent, int x, int y, int w, int h,
			int numCameras, Camera **c, Devsec *d);
	virtual ~DialogMotion();

	virtual int entering();
	virtual int leaving();

	virtual int OnMotionDetectPressed(int camera, int on);
	virtual int OnMotionNotifyPressed(int camera, int on);
	virtual int OnRecordAlwaysPressed(int camera, int on);
	virtual int OnPhoneNumberChanged();
protected:
	virtual int CreateWindows();

	static void DetectCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void NotifyCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void AlwaysCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void NumberCallback(Object *o, TEvent *e, void *d1, void *d2);

	Devsec *mApp;
	Camera **mCameras;
	int mNumCameras;
	CheckBox *mMotionDetect;
	CheckBox *mMotionNotify;
	CheckBox **mCameraRecOnMotion;
	CheckBox **mCameraRecAlways;

	TextEntry *mPhoneNumber;
};

#endif
