#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "dtk_skin.h"
#include "dtk_textentry.h"
#include "dtk_widget.h"
#include "dtk_config.h"

#include "dialog_system.h"
#include "devsec.h"

DialogSystem::DialogSystem(Widget *parent, int x, int y, int w, int h,
		Devsec *d)
	: Widget(parent, x, y, w, h)
{
	mApp = d;
	mButtonFunctions = (TextEntry**)malloc(8 * sizeof(TextEntry*));
	Config::ReadConfig("global", DTK_CONFDIR "/dev/sec/global.conf");
	CreateWindows();
}

DialogSystem::~DialogSystem()
{
}

int DialogSystem::entering()
{
	return 0;
}

int DialogSystem::leaving()
{
	Config::SetCharValue("global", "button0", 
			mButtonFunctions[0]->GetBufferPtr());
	Config::SetCharValue("global", "button1", 
			mButtonFunctions[1]->GetBufferPtr());
	Config::SetCharValue("global", "button2", 
			mButtonFunctions[2]->GetBufferPtr());
	Config::SetCharValue("global", "button3", 
			mButtonFunctions[3]->GetBufferPtr());
	Config::SetCharValue("global", "button4", 
			mButtonFunctions[4]->GetBufferPtr());
	Config::SetCharValue("global", "button5", 
			mButtonFunctions[5]->GetBufferPtr());
	Config::SetCharValue("global", "button6", 
			mButtonFunctions[6]->GetBufferPtr());
	Config::SetCharValue("global", "button7", 
			mButtonFunctions[7]->GetBufferPtr());
	return 0;
}

int DialogSystem::Show()
{
	return Widget::Show();
}

int DialogSystem::Hide()
{
	return Widget::Hide();
}

int DialogSystem::CreateWindows()
{
	Widget *frame;
	Widget *image;
	Widget *label;
	TextEntry *text;
	char *txt;

	SetColor(0xe600, 0xf700, 0xff00);

	image = new Widget(this, 0, 0, mW, 30);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(CONFIG_HDR_SYSTEM));

	frame = new Widget(this, 8, 48, mW-16, 96);
	frame->Show();
	frame->SetText("Directories", 2, 12);
	frame->DrawFrame(1);
	frame->SetColor(0xe600, 0xf700, 0xff00);

	label = new Widget(frame, 32, 36, 128, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("Streams directory", 2, 12);

	mStreamDirectory = new TextEntry(frame, 160, 32, 312, 24);
	mStreamDirectory->Show();
	txt = Config::GetCharValue("global", "streamDir", "/streams");
	mStreamDirectory->SetBuffer(txt);
	free((void*)txt);

	frame = new Widget(this, 8, 152, mW-16, 360);
	frame->Show();
	frame->DrawFrame(1);
	frame->SetColor(0xe600, 0xf700, 0xff00);
	frame->SetText("Helper Buttons", 2, 12);

	image = new Widget(frame, 100, 24, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(KFIND_NORMAL));

	mButtonFunctions[0] = new TextEntry(frame, 160, 32, 312, 24);
	mButtonFunctions[0]->Show();
	txt = Config::GetCharValue("global", "button0", "");
	mButtonFunctions[0]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 63, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(CDBAKE_NORMAL));

	mButtonFunctions[1] = new TextEntry(frame, 160, 71, 312, 24);
	mButtonFunctions[1]->Show();
	txt = Config::GetCharValue("global", "button1", "");
	mButtonFunctions[1]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 102, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(BROWSE_NORMAL));

	mButtonFunctions[2] = new TextEntry(frame, 160, 110, 312, 24);
	mButtonFunctions[2]->Show();
	txt = Config::GetCharValue("global", "button2", "");
	mButtonFunctions[2]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 141, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(SYSINFO_NORMAL));

	mButtonFunctions[3] = new TextEntry(frame, 160, 149, 312, 24);
	mButtonFunctions[3]->Show();
	txt = Config::GetCharValue("global", "button3", "");
	mButtonFunctions[3]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 180, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(DIRSTAT_NORMAL));

	mButtonFunctions[4] = new TextEntry(frame, 160, 188, 312, 24);
	mButtonFunctions[4]->Show();
	txt = Config::GetCharValue("global", "button4", "");
	mButtonFunctions[4]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 219, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(TRASH_NORMAL));

	mButtonFunctions[5] = new TextEntry(frame, 160, 227, 312, 24);
	mButtonFunctions[5]->Show();
	txt = Config::GetCharValue("global", "button5", "");
	mButtonFunctions[5]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 258, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(TIME_NORMAL));

	mButtonFunctions[6] = new TextEntry(frame, 160, 266, 312, 24);
	mButtonFunctions[6]->Show();
	txt = Config::GetCharValue("global", "button6", "");
	mButtonFunctions[6]->SetBuffer(txt);
	free((void*)txt);

	image = new Widget(frame, 100, 297, 39, 39);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(NETWORK_NORMAL));

	mButtonFunctions[7] = new TextEntry(frame, 160, 305, 312, 24);
	mButtonFunctions[7]->Show();
	txt = Config::GetCharValue("global", "button7", "");
	mButtonFunctions[7]->SetBuffer(txt);
	free((void*)txt);
}

