#include <stdlib.h>
#include <stdio.h>

#include "dtk_skin.h"
#include "dialog_tv.h"
#include "dtk_scrollview.h"
#include "devsec.h"

DialogTV::DialogTV(Widget *parent, int x, int y, int w, int h,
		int numCameras, Camera **c, Devsec *d)
	: Widget(parent, x, y, w, h)
{
	mLayout = 0;
	mCurrentLayout = NULL;
	mApp = d;
	mCameras = c;
	mNumCameras = numCameras;
	CreateWindows();
}

DialogTV::~DialogTV()
{
}

int DialogTV::entering()
{
	FillPanel();
	return 0;
}

int DialogTV::leaving()
{
	return 0;
}

int DialogTV::CreateWindows()
{
	int i;
	Widget *image;
	Widget *frame;
	Widget *label;
	ScrollView *scrollview;

	SetColor(0xe600, 0xf700, 0xff00);

	image = new Widget(this, 0, 0, mW, 30);
	image->Show();
	image->SetPixmap(Skin::GetSkinPixmap(CONFIG_HDR_TV));

	frame = new Widget(this, 12, 40, 640, 296);
	frame->Show();
	frame->SetColor(0xe600, 0xf700, 0xff00);
	frame->SetText("TV Layout", 2, 12);

	mLayout1 = new Button(frame, 8, 16, 150, 112);
	mLayout1->Show();
	mLayout1->SetToggleMode(1);
	mLayout1->SetPixmap(Skin::GetSkinPixmap(LAYOUT1_NORMAL), STATE_NORMAL);
	mLayout1->SetPixmap(Skin::GetSkinPixmap(LAYOUT1_HOVER), STATE_HOVER);
	mLayout1->SetPixmap(Skin::GetSkinPixmap(LAYOUT1_PRESSED),STATE_PRESSED);
	mLayout1->SetCallback((void*)this, (void*)1, LayoutCallback);

	mLayout2 = new Button(frame, 166, 16, 150, 112);
	mLayout2->Show();
	mLayout2->SetToggleMode(1);
	mLayout2->SetPixmap(Skin::GetSkinPixmap(LAYOUT2_NORMAL), STATE_NORMAL);
	mLayout2->SetPixmap(Skin::GetSkinPixmap(LAYOUT2_HOVER), STATE_HOVER);
	mLayout2->SetPixmap(Skin::GetSkinPixmap(LAYOUT2_PRESSED),STATE_PRESSED);
	mLayout2->SetCallback((void*)this, (void*)2, LayoutCallback);

	mLayout3 = new Button(frame, 324, 16, 150, 112);
	mLayout3->Show();
	mLayout3->SetToggleMode(1);
	mLayout3->SetPixmap(Skin::GetSkinPixmap(LAYOUT3_NORMAL), STATE_NORMAL);
	mLayout3->SetPixmap(Skin::GetSkinPixmap(LAYOUT3_HOVER), STATE_HOVER);
	mLayout3->SetPixmap(Skin::GetSkinPixmap(LAYOUT3_PRESSED),STATE_PRESSED);
	mLayout3->SetCallback((void*)this, (void*)3, LayoutCallback);

	mLayout4 = new Button(frame, 482, 16, 150, 112);
	mLayout4->Show();
	mLayout4->SetToggleMode(1);
	mLayout4->SetPixmap(Skin::GetSkinPixmap(LAYOUT4_NORMAL), STATE_NORMAL);
	mLayout4->SetPixmap(Skin::GetSkinPixmap(LAYOUT4_HOVER), STATE_HOVER);
	mLayout4->SetPixmap(Skin::GetSkinPixmap(LAYOUT4_PRESSED),STATE_PRESSED);
	mLayout4->SetCallback((void*)this, (void*)4, LayoutCallback);

	mLayout5 = new Button(frame, 8, 136, 150, 112);
	mLayout5->Show();
	mLayout5->SetToggleMode(1);
	mLayout5->SetPixmap(Skin::GetSkinPixmap(LAYOUT5_NORMAL), STATE_NORMAL);
	mLayout5->SetPixmap(Skin::GetSkinPixmap(LAYOUT5_HOVER), STATE_HOVER);
	mLayout5->SetPixmap(Skin::GetSkinPixmap(LAYOUT5_PRESSED),STATE_PRESSED);
	mLayout5->SetCallback((void*)this, (void*)5, LayoutCallback);

	mLayout6 = new Button(frame, 166, 136, 150, 112);
	mLayout6->Show();
	mLayout6->SetToggleMode(1);
	mLayout6->SetPixmap(Skin::GetSkinPixmap(LAYOUT6_NORMAL), STATE_NORMAL);
	mLayout6->SetPixmap(Skin::GetSkinPixmap(LAYOUT6_HOVER), STATE_HOVER);
	mLayout6->SetPixmap(Skin::GetSkinPixmap(LAYOUT6_PRESSED),STATE_PRESSED);
	mLayout6->SetCallback((void*)this, (void*)6, LayoutCallback);

	mLayout7 = new Button(frame, 324, 136, 150, 112);
	mLayout7->Show();
	mLayout7->SetToggleMode(1);
	mLayout7->SetPixmap(Skin::GetSkinPixmap(LAYOUT7_NORMAL), STATE_NORMAL);
	mLayout7->SetPixmap(Skin::GetSkinPixmap(LAYOUT7_HOVER), STATE_HOVER);
	mLayout7->SetPixmap(Skin::GetSkinPixmap(LAYOUT7_PRESSED),STATE_PRESSED);
	mLayout7->SetCallback((void*)this, (void*)7, LayoutCallback);

	mLayout8 = new Button(frame, 482, 136, 150, 112);
	mLayout8->Show();
	mLayout8->SetToggleMode(1);
	mLayout8->SetPixmap(Skin::GetSkinPixmap(LAYOUT8_NORMAL), STATE_NORMAL);
	mLayout8->SetPixmap(Skin::GetSkinPixmap(LAYOUT8_HOVER), STATE_HOVER);
	mLayout8->SetPixmap(Skin::GetSkinPixmap(LAYOUT8_PRESSED),STATE_PRESSED);
	mLayout8->SetCallback((void*)this, (void*)8, LayoutCallback);

	mCycling = new CheckBox(frame, 8, 264);
	mCycling->Show();
	mCycling->SetCallback((void*)this, NULL, CyclingCallback);

	label = new Widget(frame, 32, 264, 72, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetText("TV Cycling", 0, 12);
	label->SetColor(0xe600, 0xf700, 0xff00);

	frame = new Widget(this, 12, 343, 640, 192);
	frame->Show();
	frame->SetText("Show Cameras", 2, 12);
	frame->SetColor(0xe600, 0xf700, 0xff00);

	scrollview = new ScrollView(frame, 1, 20, 638, 170);
	scrollview->Show();
	scrollview->SetColor(0xffff, 0xffff, 0xffff);

	for (i = 0; i < mNumCameras; i++) {
		Widget *container;
		CheckBox *check;
		unsigned int r, g, b;

		if (i %2) r = g = b = 0xe000;
		else r = g = b = 0xffff;

		label = new Widget(scrollview, 1, 1+24*i, 382, 23);
		label->Show();
		label->DrawFrame(0);
		label->SetText(mCameras[i]->GetCameraName(),2, 14);
		label->SetColor(r, g, b);

		container = new Widget(scrollview, 383, 1+24*i, 256, 23);
		container->Show();
		container->DrawFrame(0);
		container->SetColor(r, g, b);

		check = new CheckBox(container, 121, 5);
		check->SetToggle(mApp->GetRemoteInViewList(i));
		check->Show();
		check->SetCallback((void*)this, (void*)i, ListCallback);
	}
	FillPanel();
}

int DialogTV::FillPanel()
{
	int i;

	mCycling->SetToggle(Config::GetIntValue("global", "remoteCycle", 0));

	i = Config::GetIntValue("global", "remoteLayout", 1);
	if (i==1) OnLayoutPressed(mLayout1, 1);
	if (i==2) OnLayoutPressed(mLayout2, 2);
	if (i==3) OnLayoutPressed(mLayout3, 3);
	if (i==4) OnLayoutPressed(mLayout4, 4);
	if (i==5) OnLayoutPressed(mLayout5, 5);
	if (i==6) OnLayoutPressed(mLayout6, 6);
	if (i==7) OnLayoutPressed(mLayout7, 7);
	if (i==8) OnLayoutPressed(mLayout8, 8);
	return 0;
}

int DialogTV::OnLayoutPressed(Button *layout, int num)
{
	if (mCurrentLayout) mCurrentLayout->SetToggle(0);
	layout->SetToggle(1);
	mCurrentLayout = layout;
	mLayout = num;
	mApp->DoRemoteLayout(mLayout);
	return 0;
}

int DialogTV::OnCyclingPressed()
{
	mApp->DoRemoteCycle(mCycling->GetToggle());
	return 0;
}

int DialogTV::OnListPressed(int cameraNo, int flag)
{
	mApp->SetRemoteInViewList(cameraNo, flag);
	return 0;
}

void DialogTV::LayoutCallback(Object *o, TEvent *e, void *d1, void *d2)
{
	DialogTV *d = (DialogTV*)d1;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonPress) return;

	d->OnLayoutPressed((Button*)o, (int)d2);
}

void DialogTV::CyclingCallback(Object *o, TEvent *e, void *d1, void *d2)
{
	DialogTV *d = (DialogTV*)d1;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonPress) return;
	d->OnCyclingPressed();
}

void DialogTV::ListCallback(Object *o, TEvent *e, void *d1, void *d2)
{
	DialogTV *d = (DialogTV*)d1;
	int camera = (int)d2;
	CheckBox *c = (CheckBox*)o;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonPress) return;
	d->OnListPressed(camera, c->GetToggle());
}
