#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "dtk_skin.h"
#include "dialog_users.h"
#include "devsec.h"

DialogUsers::DialogUsers(Widget *parent, int x, int y, int w, int h,
		int numCameras, Camera **c, Devsec *d)
	: Widget(parent, x, y, w, h)
{
	mApp = d;
	mCameras = c;
	mNumCameras = numCameras;
	CreateWindows();
}

DialogUsers::~DialogUsers()
{
}

int DialogUsers::entering()
{
	if (mUsername) mUsername->SetBuffer(NULL);
	if (mPassword1) mPassword1->SetBuffer(NULL);
	if (mPassword2) mPassword2->SetBuffer(NULL);
	return 0;
}

int DialogUsers::leaving()
{
	return 0;
}

int DialogUsers::UpdateUserList()
{
	FILE *f;
	char buf[1024];
	f = popen("devsec_helper userlist", "r");
	if (f == NULL) return 0;

	mListView->Clear();
	while (fgets(buf, 1024, f) != NULL) {
		char *p = strchr(buf, '\n');
		if (p) *p = '\0';
		mListView->AddEntry(buf);
	}
	pclose(f);
	if (mPassword1) mPassword1->SetBuffer(NULL);
	if (mPassword2) mPassword2->SetBuffer(NULL);
	return 0;
}

int DialogUsers::CreateWindows()
{
	Widget *title;
	Widget *frame;
	Widget *label;
	CheckBox *checkbox;

	SetColor(0xe600, 0xf700, 0xff00);

	title = new Widget(this, 0, 0, mW, 30);
	title->Show();
	title->SetPixmap(Skin::GetSkinPixmap(CONFIG_HDR_USERS));

	frame = new Widget(this, 12, 44, 640, 488);
	frame->Show();
	frame->SetText("Users", 2, 12);
	frame->SetColor(0xe600, 0xf700, 0xff00);

	label = new Widget(frame, 20, 32, 280, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("User", 2, 12);

	mUserList = new ScrollView(frame, 20, 48, 280, 428);
	mUserList->Show();
	mUserList->SetColor(0xffff, 0xffff, 0xffff);

	mListView = new ListView(mUserList, 1, 1, 262, 410);
	mListView->SetColor(0xffff, 0xffff, 0xffff);
	mListView->SetPixmap(Skin::GetSkinPixmap(MENU_HOVER),STATE_HOVER);
	mListView->SetPixmap(Skin::GetSkinPixmap(MENU_PRESSED),STATE_PRESSED);
	mListView->SetCallback((void*)this, NULL, ListViewCallback);
	mListView->Show();

	label = new Widget(frame, 336, 32, 280, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("User Name", 2, 12);

	mUsername = new TextEntry(frame, 336, 52, 280, 24);
	mUsername->Show();

	label = new Widget(frame, 336, 92, 280, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("Password", 2, 12);

	mPassword1 = new TextEntry(frame, 336, 112, 280, 24);
	mPassword1->SetHiddenText('*');
	mPassword1->Show();

	label = new Widget(frame, 336, 152, 280, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("Confirm Password", 2, 12);


	mPassword2 = new TextEntry(frame, 336, 172, 280, 24);
	mPassword2->SetHiddenText('*');
	mPassword2->Show();

	mAddButton = new Button(frame, 336, 232, 80, 32);
	mAddButton->Show();
	mAddButton->DrawFrame(0);
	mAddButton->SetText("Add", 30, 20);
	mAddButton->SetCallback((void*)this, (void*)1, ButtonCallback);
	mAddButton->SetCanHaveFocus(1);
	mAddButton->SetDrawStipple(1);

	mDeleteButton = new Button(frame, 436, 232, 80, 32);
	mDeleteButton->Show();
	mDeleteButton->DrawFrame(0);
	mDeleteButton->SetText("Delete", 16, 20);
	mDeleteButton->SetCallback((void*)this, (void*)2, ButtonCallback);
	mDeleteButton->SetCanHaveFocus(1);
	mDeleteButton->SetDrawStipple(1);

	mModifyButton = new Button(frame, 536, 232, 80, 32);
	mModifyButton->Show();
	mModifyButton->DrawFrame(0);
	mModifyButton->SetText("Modify", 16, 20);
	mModifyButton->SetCallback((void*)this, (void*)3, ButtonCallback);
	mModifyButton->SetCanHaveFocus(1);
	mModifyButton->SetDrawStipple(1);

	checkbox = new CheckBox(frame, 336, 310);
	checkbox->Show();
	checkbox->SetCallback((void*)this, NULL, CheckBoxCallback);
	checkbox->SetToolTipText("Authentication for the buttons on the main application");
	checkbox->SetToggle(mApp->GetAuthentication());

	label = new Widget(frame, 354, 310, 160, 16);
	label->Show();
	label->DrawFrame(0);
	label->SetColor(0xe600, 0xf700, 0xff00);
	label->SetText("Require Authentication", 2, 14);

	UpdateUserList();

	return 0;
}

int DialogUsers::OnButtonAddPressed()
{
	char *uname;
	char *pword1;
	char *pword2;
	char buf[1024];
	int rv;

	uname = mUsername->GetBufferPtr();
	pword1 = mPassword1->GetBufferPtr();
	pword2 = mPassword2->GetBufferPtr();

	if ((pword1 == NULL) || (pword2 == NULL) || (uname == NULL)) {
		my_system("gmessage --error Invalid input&");
		return 0;
	}
	if ((strlen(pword1) != strlen(pword2)) ||
			strncmp(pword1, pword2, strlen(pword1))) {
		my_system("gmessage --error Passwords do not match &");
		return 0;
	}

	snprintf(buf, 1024, "devsec_helper adduser %s %s", uname, pword1);
	rv = my_system(buf);
	if (rv == 65280) {
		my_system("gmessage --error User exists &");
		return 0;
	}
	UpdateUserList();
	return 0;
}

int DialogUsers::OnButtonDeletePressed()
{
	char buf[1024];

	if (mUsername->GetBufferPtr() == NULL) return 0;

	snprintf(buf, 1024, "devsec_helper deluser %s",
			mUsername->GetBufferPtr());
	my_system(buf);
	UpdateUserList();
	return 0;
}

int DialogUsers::OnButtonModifyPressed()
{
	char *uname;
	char *pword1;
	char *pword2;
	char buf[1024];
	int rv;

	uname = mUsername->GetBufferPtr();
	pword1 = mPassword1->GetBufferPtr();
	pword2 = mPassword2->GetBufferPtr();

	if ((pword1 == NULL) || (pword2 == NULL) || (uname == NULL)) {
		my_system("gmessage --error Invalid input&");
		return 0;
	}
	if ((strlen(pword1) != strlen(pword2)) ||
			strncmp(pword1, pword2, strlen(pword1))) {
		my_system("gmessage --error Passwords do not match &");
		return 0;
	}

	snprintf(buf, 1024, "devsec_helper modifyuser %s %s", uname, pword1);
	rv = my_system(buf);
	UpdateUserList();
	return 0;
}

int DialogUsers::OnListViewPressed(int entry)
{
	Widget *w = mListView->GetWidgetForEntry(entry);
	if (w == NULL) return 0;

	mUsername->SetBuffer(w->GetText());
	mPassword1->SetBuffer(NULL);
	mPassword2->SetBuffer(NULL);
	return 0;
}

int DialogUsers::OnCheckBoxPressed(int flag)
{
	mApp->SetAuthentication(flag);
	return 0;
}

void DialogUsers::ButtonCallback(Object *o,TEvent *e,void *d1,void *d2)
{
	DialogUsers *d = (DialogUsers*)d1;
	int btn = (int)d2;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonRelease) return;
	switch (btn) {
		case 1:
			d->OnButtonAddPressed();
			break;
		case 2:
			d->OnButtonDeletePressed();
			break;
		case 3:
			d->OnButtonModifyPressed();
			break;
	}
}

void DialogUsers::ListViewCallback(Object *o,TEvent *e,int i,void *d1,void *d2)
{
	DialogUsers *d = (DialogUsers*)d1;

	if (e->type != DTKEVENT) return;
	if (e->dev->type != DTK_LISTVIEW_SELECTION) return;
	d->OnListViewPressed(i);
}

void DialogUsers::CheckBoxCallback(Object *o, TEvent *e, void *d1, void *d2)
{
	DialogUsers *d = (DialogUsers*)d1;
	CheckBox *b = (CheckBox*)o;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonPress) return;
	d->OnCheckBoxPressed(b->GetToggle());
}

