#ifndef __DIALOG_USERS_H
#define __DIALOG_USERS_H

#include "dtk_widget.h"
#include "dtk_textentry.h"
#include "dtk_button.h"
#include "dtk_scrollview.h"
#include "dtk_listview.h"
#include "dtk_checkbox.h"

#include "camera.h"

class Devsec;

class DialogUsers : public Widget {
public:
	DialogUsers(Widget *parent, int x, int y, int w, int h,
			int numCameras, Camera **c, Devsec *d);
	virtual ~DialogUsers();

	virtual int entering();
	virtual int leaving();

	virtual int OnButtonAddPressed();
	virtual int OnButtonDeletePressed();
	virtual int OnButtonModifyPressed();
	virtual int OnListViewPressed(int entry);
	virtual int OnCheckBoxPressed(int flag);

protected:
	virtual int UpdateUserList();
	virtual int CreateWindows();

	static void ButtonCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void ListViewCallback(Object *o,TEvent *e,int i,
			void* d1,void *d2);
	static void CheckBoxCallback(Object *o, TEvent *e, void *d1, void *d2);

	Devsec *mApp;
	Camera **mCameras;
	int mNumCameras;
	Button *mAddButton;
	Button *mDeleteButton;
	Button *mModifyButton;
	TextEntry *mUsername;
	TextEntry *mPassword1;
	TextEntry *mPassword2;
	ScrollView *mUserList;
	ListView *mListView;
};

#endif
