#ifndef __CONFIGDIALOG_H
#define __CONFIGDIALOG_H

#include "dtk_object.h"
#include "dtk_widget.h"
#include "camera.h"
#include "dialog_about.h"
#include "dialog_camera.h"
#include "dialog_global.h"
#include "dialog_motion.h"
#include "dialog_tv.h"
#include "dialog_users.h"
#include "dialog_system.h"

class Devsec;

class ConfigDialog : public Object {
public:
	ConfigDialog(int numCameras, Camera **c, Devsec *d);
	virtual ~ConfigDialog();

	virtual int Show();
	virtual int Hide();
	virtual int EventHandler(TEvent *ev);
	virtual int DoWindowDestroy(Widget *window);

	virtual int DoToolbarBtnPressed(Widget *newPanel);

	virtual int OnBtnSave();
	virtual int OnBtnCancel();

protected:
	virtual int CreateWindows();

	static void WindowCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void ToolbarBtnCallback(Object *o,TEvent *e,void *d1,void *d2);
	static void StatusBtnCallback(Object *o,TEvent *e,void *d1,void *d2);

	int mNumCameras;
	Camera **mCameras;
	Devsec *mApp;

	Widget *mMainWindow;
	DialogAbout *mAboutPanel;
	DialogCamera *mCameraPanel;
	DialogGlobal *mGlobalPanel;
	DialogMotion *mMotionPanel;
	DialogTV *mTVPanel;
	DialogUsers *mUserPanel;
	DialogSystem *mSystemPanel;

	Widget *mCurrentPanel;
};

#endif
