#ifndef __MODEM_H
#define __MODEM_H

typedef struct {
	char *phone_number;
	int dev_fd;
	char *audio_buf;
	int buf_size;
	int offhook;
} modem_t;

modem_t *modem_new();
int modem_free(modem_t *modem);

int modem_open_device(modem_t *modem, char *device);
int modem_close_device(modem_t *modem);
int modem_send_buffer(modem_t *modem, char *buf, unsigned long buf_size);
int modem_send_line(modem_t *modem, char *line);
char *modem_get_line(modem_t *modem);
int modem_check_response(modem_t *modem, char *resp);
int modem_dial(modem_t *modem);
int modem_set_number(modem_t *modem, char *phone_number);
int modem_set_audio(modem_t *modem, char *buf, unsigned long size);
int modem_hangup(modem_t *modem);
int modem_send_message(modem_t *modem);

#endif
