#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "devsec.h"
#include "devsecremote.h"
#include "devsecconsumer.h"


#define NORMAL_MODE 0
#define REMOTE_MODE 1
#define CONSUMER_MODE 2

int main(int argc, char *argv[])
{
	int i;
	int mode = NORMAL_MODE;

	if (argc <= 1) goto noargs;
	for (i = 1; i < argc; i++) {
		if (!strncmp(argv[i], "--remote", 8)) mode = REMOTE_MODE;
		if (!strncmp(argv[i], "--consumer", 10)) mode = CONSUMER_MODE;
	}

noargs:
	switch (mode) {
		case NORMAL_MODE: {
				Devsec *devsec;
				devsec = new Devsec();

				devsec->Init(argc, argv);
				devsec->Run();
				devsec->Destroy();
				delete devsec;
			}
			break;
		case REMOTE_MODE: {
				DevsecRemote *devsec;
				devsec = new DevsecRemote();

				devsec->Init(argc, argv);
				devsec->Run();
				devsec->Destroy();
				delete devsec;
			}
			break;
		case CONSUMER_MODE: {
				DevsecConsumer *devsec;
				devsec = new DevsecConsumer();

				devsec->Init(argc, argv);
				devsec->Run();
				devsec->Destroy();
				delete devsec;
		    	}
			break;
	}
	return 0;
}
