#ifndef __LIBEFF_H
#define __LIBEFF_H

#define video_width 384
#define video_height 288
#define screen_width 384
#define screen_height 288
#define screen_scale 2
#define video_area video_width*video_height
typedef unsigned int RGB32;

#ifdef __cplusplus
extern "C" {
#endif

int image_init();
void image_end();
void image_stretching_buffer_clear(RGB32 color);
void image_stretch(RGB32 *src, int src_width, int src_height,
			RGB32 *dest, int dest_width, int dest_height);
void image_stretch_to_screen();
void image_set_threshold_y(int threshold);
void image_bgset_y(RGB32 *src);
unsigned char *image_bgsubtract_y(RGB32 *src);
unsigned char *image_bgsubtract_update_y(RGB32 *src);
void image_set_threshold_RGB(int r, int g, int b);
void image_bgset_RGB(RGB32 *src);
unsigned char *image_bgsubtract_RGB(RGB32 *src);
unsigned char *image_bgsubtract_update_RGB(RGB32 *src);
unsigned char *image_diff_filter(unsigned char *diff);
unsigned char *image_y_over(RGB32 *src);
unsigned char *image_y_under(RGB32 *src);
void image_hflip(RGB32 *src, RGB32 *dest, int width, int height);

void *rippleRegister();
int draw(RGB32 *src, RGB32 *dest);
#ifdef __cplusplus
}
#endif

#endif
