#ifndef __MESSAGE_H
#define __MESSAGE_H

#include "file_mp4_recorder.h"
#include "socket.h"
#include "graphics.h"
#include "mp4live.h"
#include "media_flow.h"
#include "motion.h"
#include "rtp_transmitter.h"

class MessageHandler {
public:
	MessageHandler(CAVMediaFlow *pFlow, CLiveConfig *pConfig);
	virtual int handle_message(char *buf);
	virtual int set_objects(PreviewWindow *lp,PreviewWindow *rp,
			Socket *s, Motion *m);
	virtual inline int is_recording() { return recording; };
	virtual int StopRecording();
	virtual int StartRecording();
	virtual int StartUnicast(char *addr, char *port);
	virtual int StopUnicast();

protected:
	virtual int handle_v4l_message(char *message);
	virtual int handle_motion_message(char *message);
	virtual int handle_preview_message(char *message);
	virtual int handle_mpeg_message(char *message);
	virtual int handle_text_message(char *message);
	virtual int handle_restart_message();
	virtual int handle_unicast_message(char *message);

	PreviewWindow *mLocalPreview;
	PreviewWindow *mRemotePreview;
	Socket *mSocket;
	Motion *mMotion;
	CAVMediaFlow *mFlow;
	CLiveConfig *mConfig;
	// These shouldn't go here
	CMp4Recorder *mMp4Recorder;
	CRtpTransmitter *mRtpTransmitter;

	int recording;
};
#endif
