#ifndef __MOTION_H
#define __MOTION_H

typedef struct {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} rgb24_t ;

class Motion {
public:
	Motion();
	virtual ~Motion();
	virtual int set_sensitivity(unsigned int sensitivity);
	virtual int set_bounds(unsigned long x1, unsigned long y1,
			unsigned long x2, unsigned long y2);
	virtual int set_showmotion(unsigned char showmotion);
	virtual int set_showbounds(unsigned char showbounds);
	virtual int detect_motion(unsigned char *buffer);

	int sent_motion_event;

protected:
	virtual int process_image();
	virtual int compare_blocks(unsigned long *x1, unsigned long *y1,
			unsigned long *x2, unsigned long *y2);
	virtual int add_point(unsigned long *x1, unsigned long *y1,
			unsigned long *x2, unsigned long *y2,
			unsigned long x, unsigned long y);
	virtual int draw_box(unsigned char *buffer,
			unsigned long x1, unsigned long y1,
			unsigned long x2, unsigned long y2);

	unsigned long mX1;
	unsigned long mY1;
	unsigned long mX2;
	unsigned long mY2;
	unsigned int mSensitivity;
	unsigned char mShowMotion;
	unsigned char mShowBounds;
	unsigned char *mVideoBuf[2];
	unsigned char mActiveBuf;
	rgb24_t *mBlocks[2];
	int mFirst;
	int mTicks;
	int mDepth;
};
#endif
