#ifndef __MOTION_H
#define __MOTION_H

typedef unsigned int rgb24_t;

class Motion {
public:
	Motion();
	virtual ~Motion();
	virtual int set_sensitivity(unsigned int sensitivity);
	virtual int set_bounds(unsigned long x1, unsigned long y1,
			unsigned long x2, unsigned long y2);
	virtual int set_showmotion(unsigned char showmotion);
	virtual int set_showbounds(unsigned char showbounds);
	virtual int detect_motion(unsigned char *buffer);

	int sent_motion_event;

protected:
	virtual void image_set_threshold_y(int threshold);
	virtual void image_bgset_y(rgb24_t *src);
	virtual unsigned char *image_bgsubtract_y(rgb24_t *src);
	virtual unsigned char *image_bgsubtract_update_y(rgb24_t *src);
	virtual void image_set_threshold_RGB(int r, int g, int b);
	virtual void image_bgset_RGB(rgb24_t *src);
	virtual unsigned char *image_bgsubtract_RGB(rgb24_t *src);
	virtual unsigned char *image_bgsubtract_update_RGB(rgb24_t *src);
	virtual unsigned char *image_diff_filter(unsigned char *diff);
	virtual unsigned char *image_y_over(rgb24_t *src);
	virtual unsigned char *image_y_under(rgb24_t *src);
	virtual void image_hflip(rgb24_t *src, rgb24_t *dest, int w, int h);

	virtual int motiondetect(rgb24_t *src);
	virtual int setBackground(rgb24_t *src);


	
	virtual int add_point(unsigned int x, unsigned int y);
	virtual int draw_box(unsigned char *buffer,
			unsigned int x1, unsigned int y1,
			unsigned int x2, unsigned int y2);

	unsigned long mX1;
	unsigned long mY1;
	unsigned long mX2;
	unsigned long mY2;
	unsigned int mSensitivity;
	unsigned char mShowMotion;
	unsigned char mShowBounds;

	rgb24_t *background;
	unsigned char *diff;
	unsigned char *diff2;
	int y_threshold;
	rgb24_t rgb_threshold;

	int bgIsSet;
	unsigned int boxX1;
	unsigned int boxY1;
	unsigned int boxX2;
	unsigned int boxY2;
};
#endif
