#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "tsrep_com.h"

char *pipeName = NULL;

static int pipefd = -1;
static int framecount = 0;

int tsrep_com_open_pipe()
{
	int filedes[2];
	if (pipeName == NULL) {
		fprintf(stderr, "using internal pipes\n");
		pipe(filedes);
		pipefd = filedes[1];
		return filedes[0];
	}
	mkfifo(pipeName, 0666);
	pipefd = open(pipeName, O_WRONLY);
	return 0;
}

int tsrep_com_close_pipe()
{
	if (pipefd >= 0) close(pipefd);

	return 0;
}

int tsrep_com_send_frame(struct ts_frame *f)
{
	static int dont_really_send = 1;
	if (pipefd < 0) return 0;
	if (f == NULL) return 0;

	if (dont_really_send) {
		dont_really_send = 0;
		return 0;
	}

	dont_really_send = 1;
	write(pipefd, &(f->fh), sizeof(struct frame_header));
	write(pipefd, (const void*)f->data, f->fh.length);
	return 0;
}

