#ifndef __BUTTON_H
#define __BUTTON_H

#include "dtk_widget.h"
#include "dtk_tooltip.h"

#define STATE_NORMAL 0
#define STATE_HOVER 1
#define STATE_PRESSED 2

class Button : public Widget {
public:
	Button(Widget *parent, int x, int y, int w, int h);
	virtual ~Button();
	virtual int Destroy();

	virtual int LostFocus();
	virtual int SetToggleMode(int flag);
	virtual int SetToggle(int flag);
	virtual inline int GetToggle() { return mToggled; };

	virtual int EventHandler(TEvent *ev);
	virtual int Draw();
	virtual int SetPixmap(Pixmap p, int type);
	virtual inline int SetDrawStipple(int flag) { mDrawStipple = flag; };
	virtual int SetColor(unsigned long background);
	virtual int SetColor(unsigned int r, unsigned int g, unsigned int b);
	virtual int SetColor(unsigned long background, int type);
	virtual int SetColor(unsigned int r, unsigned int g, unsigned int b, int type);
	virtual int SetForegroundColor(unsigned int r, unsigned int g, unsigned int b);
	virtual int SetForegroundColor(unsigned long foreground);
	virtual int SetForegroundColor(unsigned int r, unsigned int g, unsigned int b, int type);
	virtual int SetForegroundColor(unsigned long foreground, int type);
protected:
	virtual int HandleKeyRelease(XEvent *xev);
	Pixmap mNormal;
	Pixmap mHover;
	Pixmap mPressed;
	unsigned long mNormalForeground;
	unsigned long mNormalBackground;
	unsigned long mHoverForeground;
	unsigned long mHoverBackground;
	unsigned long mPressedForeground;
	unsigned long mPressedBackground;
	int mState;
	int mToggleMode;
	int mToggled;
	int mDrawStipple;

	int mButtonPressCount; // Fix for X.org
};

#endif
