#ifndef __COMBOBOX_H
#define __COMBOBOX_H

#include "dtk_widget.h"
#include "dtk_textentry.h"
#include "dtk_popup.h"
#include "dtk_button.h"

class ComboBox : public Widget {
public:
	ComboBox(Widget *parent, char *contents, int num_entries,
			int x, int y, int w, int h);
	virtual ~ComboBox();

	virtual int OnPopupReleased(int selected);
	virtual int OnButtonPressed();
	virtual char *GetEntry();
	virtual inline int GetSelected() { return mSelected; };
	virtual int SetText(char *text);

protected:
	static void PopupCallback(Object *o, TEvent *e, int entry,
			void *d1, void *d2);
	static void ButtonCallback(Object *o, TEvent *e, void *d1, void *d2);

	int mSelected;
	Button *mButton;
	TextEntry *mTextEntry;
	Popup *mPopup;
	int mNumEntries;
	char *mContents;
};

#endif
