#ifndef __CONFIG_H
#define __CONFIG_H

typedef struct {
	char *variable;
	char *value;
} CValue;

class Config {
public:
	Config() {};
	virtual ~Config() {};
	static int ReadConfig(char *section, char *filename);
	static int WriteConfig(char *section, char *filename);
	static int GetIntValue(char *section, char *variable, int def);
	static long GetLongValue(char *section, char *variable, long def);
	static char *GetCharValue(char *section, char *variable, char *def);
	static int SetIntValue(char *section, char *variable, int value);
	static int SetLongValue(char *section, char *variable, long value);
	static int SetCharValue(char *section, char *variable, char *value);
	static int FreeEnvironment();
protected:
	static int GetValue(char *section, char *variable, char *buf[]);
	static int ParseConfig(char *section, char *buf);
	static int ReadLine(int fd, char *buffer, int length);

	static CValue *sValues;
	static int sNumValues;
};

#endif
