#ifndef __EVENT_H
#define __EVENT_H

#include <X11/X.h>
#include <X11/Xlib.h>

#define NOEVENT 0
#define XEVENT 1
#define TIMEEVENT 2
#define DTKEVENT 3

#define DTK_WINDOW_DESTROY 1
#define DTK_SLIDER_CHANGED 2
#define DTK_SPINBOX_CHANGED 3
#define DTK_COMBO_CHANGED 4
#define DTK_TEXTENTRY_CHANGED 5
#define DTK_LISTVIEW_SELECTION 6
#define DTK_USEREVENT 7

typedef struct {
	int type;
	void *object;
} DtkObjectDestroy;

typedef struct {
	int type;
	float value;
} DtkSliderChanged;

typedef struct {
	int type;
	int value;
} DtkSpinboxChanged;

typedef struct {
	int type;
	void *object;
} DtkComboChanged;

typedef struct {
	int type;
	void *object;
} DtkTextEntryChanged;

typedef struct {
	int type;
	void *object;
} DtkListViewSelection;

typedef struct {
	int type;
	int usertype;
	void *data1;
	void *data2;
} DtkUserEvent;

typedef union {
	int type;
	DtkObjectDestroy destroy;
	DtkSliderChanged slider;
	DtkSpinboxChanged spinbox;
	DtkComboChanged combobox;
	DtkTextEntryChanged textentry;
	DtkListViewSelection listview;
	DtkUserEvent userevent;
} DTKEvent;

typedef struct {
	int type;
	XEvent *xev;
	DTKEvent *dev;
} TEvent;

#endif
