#ifndef __LISTVIEW_H
#define __LISTVIEW_H

#include "dtk_scrollview.h"
#include "dtk_widget.h"

class ListView : public Widget {
public:
	ListView(Widget *parent, int x, int y, int w, int h);
	virtual ~ListView();

	virtual int SetScrolledParent(ScrollView *sv);
	virtual int AddEntry(char *text);
	virtual int RemoveEntry(int entry);
	virtual int Clear();
	virtual int GetSelectedEntry();
	virtual int SetSelectedEntry(int entry);
	virtual char *GetEntryText(int entry);

	virtual int SetColor(unsigned int r, unsigned int g, unsigned int b);
	virtual int SetPixmap(Pixmap p, int type);
	virtual int SetCallback(void *data1, void *data2,
			void (*cb)(Object*, TEvent*, int, void*, void*));

	virtual int OnEntrySelected(int entry);
	virtual Widget *GetWidgetForEntry(int entry);
	virtual inline int GetNumEntries() { return mNumEntries; };
protected:
	virtual int reflow();

	static void ButtonCallback(Object *o, TEvent *e, void *d1, void *d2);

	int mNumEntries;
	int mSelectedEntry;
	Pixmap mNormal;
	Pixmap mHover;
	Pixmap mPressed;
	ScrollView *mScrolledParent;

	void (*mCallback)(Object*,TEvent*,int,void*,void*);
};

#endif
