#ifndef __OBJECT_H
#define __OBJECT_H

#include "dtk_event.h"

#if 1
#define ENTER
#else
#define ENTER fprintf(stderr, "entering %s\n", __PRETTY_FUNCTION__)
#endif

#define OBJTYPE_OBJECT 0
#define OBJTYPE_WIDGET 1

class Object {
public:
	Object();
	virtual ~Object();
	virtual int Destroy();
	virtual int EventHandler(TEvent *ev);
	virtual int InsertEvent(TEvent *ev);
	virtual int AddChild(Object *child);
	virtual int RemoveChild(Object *child);
	virtual inline Object *GetFirstChild() { return mFirstChild; };
	virtual Object *GetNextChild();
	virtual Object *GetPrevChild();
	virtual Object *GetParent();
	virtual int SetNextChild(Object *child);
	virtual int SetPrevChild(Object *child);
	virtual int SetParent(Object *parent);
	virtual int GetObjectType();
protected:
	Object *mFirstChild;
	Object *mNextChild;
	Object *mPrevChild;
	Object *mParentObject;
	int mObjectType;
};

#endif
