#ifndef __POPUP_H
#define __POPUP_H

#include "dtk_widget.h"
#include "dtk_button.h"

class Popup : public Widget {
public:
	Popup(Widget *parent, char *contents, int num_entries,
			int x, int y, int w, int h, int fixed);
	Popup(Widget *parent, char *contents, int num_entries);
	virtual ~Popup();
	virtual int CreatePopup(char *contents, int num_entries);
	virtual int Show();
	virtual int Hide();
	virtual int SetPixmap(Pixmap p, int type);
	virtual int EventHandler(TEvent *ev);
	virtual int SetCallback(void *data1, void *data2,
			void (*cb)(Object*, TEvent*, int, void*, void*));
	virtual int CallCallback(TEvent *ev, int data);
	virtual int SetEntryText(char *text, int entry);
protected:
	static void EntryCallback(Object *obj, TEvent *ev,
			void *data1, void *data2);
	char *mContents;
	int mNumEntries;
	int mFixed;

	void *mData1;
	void *mData2;
	void (*mCallback)(Object*, TEvent*, int, void*, void*);

};

#endif
