#ifndef __SCROLLVIEW_H
#define __SCROLLVIEW_H

#include "dtk_widget.h"
#include "dtk_slider.h"

class ScrollView : public Widget {
public:
	ScrollView(Widget *parent, int x, int y, int w, int h);
	virtual ~ScrollView();

	virtual int MakeVisible(int x, int y, int w, int h);
	virtual int SetColor(unsigned int r, unsigned int g, unsigned int b);
	virtual int AddChild(Object *child);
	virtual int RemoveChild(Object *child);
	virtual int OnVScrollMove();
	virtual int OnHScrollMove();

	virtual Window GetXWindow();

protected:
	static void ScrollCallback(Object *o, TEvent *e, void *d1, void *d2);

	int mScrollX;
	int mScrollY;

	int ignoreNextChild;

	Widget *mScrollArea;
	Slider *mHScroll;
	Slider *mVScroll;
};
#endif
