#ifndef __SLIDER_H
#define __SLIDER_H

#include "dtk_widget.h"
#include "dtk_button.h"

#ifndef HORIZONTAL
#define HORIZONTAL 0
#define VERTICAL 1
#endif

class Slider : public Widget {
public:
	Slider(Widget *parent, int x, int y, int w, int h, int orientation);
	virtual ~Slider();
	virtual float GetValue();
	virtual int SetValue(float value);
	virtual int SetRange(int min, int max);
	virtual int OnButtonPress(int x, int y);
	virtual int OnButtonRelease();
	virtual int OnMouseMove(int x, int y);

protected:
	virtual int MoveButton(int delta);
	virtual int PercentToPixels(float Percent);
	static void ButtonCallback(Object *o, TEvent *e, void *d1, void *d2);

	Button *mSliderButton;
	int mOrientation;
	int mMinValue;
	int mMaxValue;
	int mValue;
	int mOldX;
	int mOldY;
	int mGrabbed;
};
#endif
