#ifndef __SPINBOX_H
#define __SPINBOX_H

#include "dtk_widget.h"
#include "dtk_button.h"
#include "dtk_textentry.h"

class SpinBox : public Widget {
public:
	SpinBox(Widget *parent, int x, int y, int w, int h);
	virtual ~SpinBox();

	virtual int GetValue();
	virtual int SetValue(int value);
	virtual int SetRange(int min, int max);
	virtual int OnButtonPress(int direction);
	virtual int OnTextChanged();

protected:
	static void ButtonCallback(Object *o, TEvent *e, void *d1, void *d2);
	static void TextCallback(Object *o, TEvent *e, void *d1, void *d2);

	int mValue;
	int mMinValue;
	int mMaxValue;
	Button *mUpButton;
	Button *mDownButton;
	TextEntry *mTextEntry;
};

#endif
