#ifndef __TEXTENTRY_H
#define __TEXTENTRY_H

#include "dtk_widget.h"
#include "dtk_timer.h"

class TextEntry : public Widget {
public:
	TextEntry(Widget *parent, int x, int y, int w, int h);
	virtual ~TextEntry();

	virtual int EventHandler(TEvent *ev);
	virtual int Draw();

	virtual int SetFocus();
	virtual int SetBuffer(char *buffer);
	virtual char *GetBuffer();
	virtual char *GetBufferPtr();
	virtual int GetBufferLength();
	virtual int SetTextOffset(unsigned int offset);
	virtual int SetText(char *text, int x, int y);
	virtual inline int SetHiddenText(char c) { mHiddenTextChar = c; };

	virtual int SetFlashingCursor(bool on);
	virtual int DoCursor();
protected:
	virtual int GetBufferPosFromCoords(int x, int y);
	virtual int AddChar(char c);
	virtual int DeleteChar();
	virtual int HandleKeyPress(XEvent *xev);
	static void CursorTimerCallback(void *data1, void *data2);
	static Cursor sCursor;

	char *mBuffer;
	int mBufferSize;
	int mBufferIndex;
	int mCursorIndex;
	int mBufferStart;
	Timer *mCursorTimer;
	int mCursorOn;
	int mShowCursor;
	int mCursorPos;
	char mHiddenTextChar;
	bool mFlashingCursor;
};

#endif
