#ifndef __TIMER_H
#define __TIMER_H

#include <sys/time.h>

#include "dtk_object.h"

class Timer : public Object {
public:
	Timer(unsigned int duration, void *data1, void *data2,
			void (*go)(void*, void*));
	Timer(struct timeval *tv, void *data1, void *data2,
			void (*go)(void*, void*));
	virtual ~Timer();
	virtual int EventHandler(TEvent *ev);
	virtual int Stop();
	virtual int Start();
	virtual int SetDuration(unsigned int duration);
	virtual int SetDuration(struct timeval *tv);

protected:
	int mRunning;
	unsigned int mDuration;
	void *mData1;
	void *mData2;
	void (*mCallback)(void*, void*);
	time_t mStartTime;
	struct timeval mMSDuration;
	struct timeval mMSStartTime;
	int mMSMode;
};

#endif
