#ifndef __VIDEOBOX_H
#define __VIDEOBOX_H

#include <Imlib.h>
#include <xine.h>
#include "widget.h"

class VideoBox : public Widget {
public:
	VideoBox(Widget *parent, int x, int y, int w, int h);
	virtual ~VideoBox();
	virtual int OpenFile(char *filename);
	virtual int CloseFile();
	virtual int Play();
	virtual int Pause();
	virtual int Stop();
	virtual int Faster();
	virtual int Slower();
	virtual int TakeShot(char *fname);

	virtual inline double GetAspect() { return pixel_aspect; };
protected:
	static void DestSizeCB(void *data,
			int video_width, int video_height,
			double video_pixel_aspect,
			int *dest_width, int *dest_height,
			double *dest_pixel_aspect);
	static void FrameOutputCB(void *data,
			int video_width, int video_height,
			double video_pixel_aspect,
			int *dest_x, int *dest_y,
			int *dest_width, int *dest_height,
			double *dest_pixel_aspect,
			int *win_x, int *win_y);
	static void XineEventCB(void *data, const xine_event_t *ev);

	xine_t *xine;
	xine_stream_t *stream;
	xine_video_port_t *video_port;
	xine_audio_port_t *audio_port;

	x11_visual_t vis;
	double pixel_aspect;
	int screen;
	int mTrickMode;
	Display *xineDisplay;

	ImlibData *mImData;
};
#endif
