#include "dtk_dialog.h"
#include "dtk_textentry.h"
#include "dtk_skin.h"
#include "dtk_button.h"

Dialog::Dialog(Widget *mainWindow, Widget *parent, int x, int y, int w, int h,
		int buttons)
	: Widget(parent, x, y, w, h)
{
	XSizeHints size_hints;
	Window win;

	mButtons = buttons;
	mResponse = DIALOG_BUTTON_NONE;
	if (mainWindow == NULL) mainWindow = parent;
	if (mainWindow) win = mainWindow->GetXWindow();
	else win = DefaultRootWindow(mDisplay);
	XSetTransientForHint(mDisplay, mWindow, win);
	Hide();
	CreateWindow();
	SetResizable(0);
}

Dialog::~Dialog()
{
}

int Dialog::CreateWindow()
{
	Button *button;
	int x, y;

	x = mW - 88;
	y = mH - 40;
	if (mButtons & DIALOG_BUTTON_OK) {
		button = new Button(this, x, y, 80, 32);
		button->Show();
		button->DrawFrame(0);
		button->SetText("Ok", 36, 20);
		button->SetPixmap(Skin::GetSkinPixmap(OK_NORMAL), STATE_NORMAL);
		button->SetPixmap(Skin::GetSkinPixmap(OK_HOVER), STATE_HOVER);
		button->SetPixmap(Skin::GetSkinPixmap(OK_PRESSED), STATE_PRESSED);
		button->SetCallback((void*)this, (void*)DIALOG_BUTTON_OK,
				ButtonCallback);
		button->SetCanHaveFocus(1);
		button->SetDrawStipple(1);
		x -= 80;
	}
	if (mButtons & DIALOG_BUTTON_CANCEL) {
		button = new Button(this, x, y, 80, 32);
		button->Show();
		button->DrawFrame(0);
		button->SetText("Cancel", 26, 20);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_NORMAL), STATE_NORMAL);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_HOVER), STATE_HOVER);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_PRESSED), STATE_PRESSED);
		button->SetCallback((void*)this, (void*)DIALOG_BUTTON_CANCEL,
				ButtonCallback);
		button->SetCanHaveFocus(1);
		button->SetDrawStipple(1);
		x -= 80;
	}
	if (mButtons & DIALOG_BUTTON_YES) {
		button = new Button(this, x, y, 80, 32);
		button->Show();
		button->DrawFrame(0);
		button->SetText("Yes", 35, 20);
		button->SetPixmap(Skin::GetSkinPixmap(OK_NORMAL), STATE_NORMAL);
		button->SetPixmap(Skin::GetSkinPixmap(OK_HOVER), STATE_HOVER);
		button->SetPixmap(Skin::GetSkinPixmap(OK_PRESSED), STATE_PRESSED);
		button->SetCallback((void*)this, (void*)DIALOG_BUTTON_YES,
				ButtonCallback);
		button->SetCanHaveFocus(1);
		button->SetDrawStipple(1);
		x -= 80;
	}
	if (mButtons & DIALOG_BUTTON_NO) {
		button = new Button(this, x, y, 80, 32);
		button->Show();
		button->DrawFrame(0);
		button->SetText("No", 36, 20);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_NORMAL), STATE_NORMAL);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_HOVER), STATE_HOVER);
		button->SetPixmap(Skin::GetSkinPixmap(CANCEL_PRESSED), STATE_PRESSED);
		button->SetCallback((void*)this, (void*)DIALOG_BUTTON_NO,
				ButtonCallback);
		button->SetCanHaveFocus(1);
		button->SetDrawStipple(1);
		x -= 80;
	}
}

int Dialog::OnButtonPressed(int button)
{
	mResponse = button;
	return 0;
}

int Dialog::GetResult()
{
	return mResponse;
}

void Dialog::ButtonCallback(Object *o, TEvent *e, void *data1, void *data2)
{
	Dialog *d = (Dialog*)data1;
	int button = (int)data2;

	if (e->type != XEVENT) return;
	if (e->xev->type != ButtonRelease) return;
	d->OnButtonPressed(button);
}
