#include <stdlib.h>
#include <stdio.h>

#include "dtk_meter.h"

Meter::Meter(Widget *parent, int x, int y, int w, int h, int orientation)
	:Widget(parent, x, y, w, h)
{
	mPercent = 0.0;
	mOrientation = orientation;

	if (mOrientation == HORIZONTAL)
		mBar = new Widget(this, 0, 0, 1, h);
	else
		mBar = new Widget(this, 0, 0, w, 1);
	mBar->Show();
	mBar->DrawFrame(0);
}

Meter::~Meter()
{
}

int Meter::SetPercent(double percent)
{
	if (percent < 0.0) percent = 0;
	if (percent > 100.0) percent = 100.0;
	mPercent = percent;

	if (mOrientation == HORIZONTAL) {
		int w;
		w = (int)((double)mW * mPercent / 100.0);
		mBar->Resize(w, -1);
	} else {
		int h;
		h = (int)((double)mH * (100-mPercent) / 100.0);
		mBar->Resize(-1, h);
	}
	return 0;
}

int Meter::SetPixmap(Pixmap p, int type)
{
	if (type == METER_BACKGROUND) {
		switch (mOrientation) {
			case HORIZONTAL:
				return Widget::SetPixmap(p);
			case VERTICAL:
				return mBar->SetPixmap(p);
		}
	} else {
		switch (mOrientation) {
			case VERTICAL:
				return Widget::SetPixmap(p);
			case HORIZONTAL:
				return mBar->SetPixmap(p);
		}
	}
}
