#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "dtk_tooltip.h"

ToolTip::ToolTip(BaseWidget *parent)
	: BaseWidget(parent, 0, 0, 1, 1)
{
	ENTER;
	mTimer = NULL;
	mText = NULL;
	BaseWidget::Hide();
}

ToolTip::~ToolTip()
{
	if (mText) {
		free((void*)mText);
		mText = NULL;
	}
}

int ToolTip::Show()
{
	int direction, ascent, descent;
	XCharStruct overall;

	if (mText == NULL) return 0;

	if (mTimer) mTimer->Start();
	else {
		mTimer = new Timer(1, this, NULL, ToolTip::TimerCallback);
		AddChild(mTimer);
	}

	XTextExtents(mFont, mText, strlen(mText), &direction,
			&ascent, &descent, &overall);

	mW = overall.width + 4;
	mH = ascent + descent + 4;
	Resize(mW, mH);

	mTextY = ascent + 2;

	XUnmapWindow(mDisplay, mWindow);
	return 0;
}

int ToolTip::ReallyShow()
{
	Window wjunk;
	int ijunk, x, y;
	unsigned int ujunk;

	if (mText == NULL) return 0;
	if (mVisible) return 0;

	XQueryPointer(mDisplay, mParent->GetXWindow(),
			&wjunk, &wjunk, &ijunk, &ijunk,
			&x, &y, &ujunk);
	if (mParent) {
		Window rr;
		int xr, yr;
		unsigned int wr, hr, bwr, dr;
		wjunk = mParent->GetXWindow();
		XGetGeometry(mDisplay, wjunk, &rr,&xr,&yr,&wr,&hr,&bwr,&dr);
		if (x + mW > wr) x = wr - mW - 12;
		if (y + mH > hr) y = hr - mH - 12;
	}
	Move(x + 10, y + 10);
	BaseWidget::Show();
	return 0;
}

int ToolTip::Hide()
{
	if (mText == NULL) return 0;

	if (mTimer) mTimer->Stop();
	return BaseWidget::Hide();
}

int ToolTip::SetText(char *text)
{
	return BaseWidget::SetText(text, 2, mH - 4);
}

void ToolTip::TimerCallback(void *d1, void *d2)
{
	ToolTip *tt = (ToolTip*)d1;
	if (d1 == NULL) return;

	tt->ReallyShow();
}
